# TODO:
# - --with-ssh=/usr/bin/ssh does has no effect, it still tries to find ssh from $PATH and fail
#   (as of 1.4g, configure is older than configure.ac and probably somehow hacked)
Summary:	Automatically restart SSH sessions and tunnels
Summary(pl.UTF-8):	Automatyczny restart sesji i tuneli SSH
Name:		autossh
Version:	1.4g
Release:	1
# autossh.c contains 0-clause BSD, daemon.h 4-clause BSD
License:	BSD
Group:		Applications/Networking
Source0:	https://www.harding.motd.ca/autossh/%{name}-%{version}.tgz
# Source0-md5:	2b804bc1bf6d2f2afaa526d02df7c0a2
Source1:	%{name}.init
Source2:	%{name}.tab
Source3:	%{name}.tmpfiles
URL:		https://www.harding.motd.ca/autossh/
BuildRequires:	rpmbuild(macros) >= 1.647
Requires:	openssh-clients
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Autossh is a program to start a copy of ssh and monitor it, restarting
it as necessary should it die or stop passing traffic. The idea and
the mechanism are from rstunnel (Reliable SSH Tunnel), but implemented
in C. The author's view is that it is not as fiddly as rstunnel to get
to work. Connection monitoring using a loop of port forwardings. Backs
off on rate of connection attempts when experiencing rapid failures
such as connection refused. Compiled and tested on OpenBSD, Linux, and
Solaris; should work fine on other BSDs (except Mac OS 10).

%description -l pl.UTF-8
autossh jest programem uruchamiającym kopię ssh i monitorującym ją,
restartując w miarę potrzeby, jeśli umrze lub przestanie przekazywać
ruch. Idea i mechanizm pochodzą z rstunnela (Reliable SSH Tunnel), ale
zaimplementowano je w C. Według autora nie trzeba się tak patyczkować,
jak z rstunnelem, aby go uruchomić. Monitorowanie połączenia używa
pętli przekazywania portów. Częstotliwość prób połączeń jest
zmniejszana w przypadku napotkania nagłych awarii, takich jak
odrzucenie połączenia. Program skompilowano i sprawdzono na OpenBSD,
Linuksie i Solarisie; powinien działać także na innych BSD (oprócz
MacOS 10).

%package init
Summary:	autossh configuration as system service
Summary(pl.UTF-8):	konfiguracja autossh jako usługi systemowej
Group:		Networking/Daemons
Requires(post,preun):	/sbin/chkconfig
Requires:	%{name} = %{version}-%{release}
Requires:	awk
Requires:	rc-scripts >= 0.4.0.20

%description init
this package contains init script and example configuration file, that
allows to run autossh as Unix system service.

%description init -l pl.UTF-8
Ten pakiet zawiera skrypt startowy oraz przykładowy plik
konfiguracyjny, które pozwalają uruchamić autossh jako uniksową usługę
systemową.

%prep
%setup -q

%build
%configure \
	ac_cv_lib_nsl_gethostbyname=no \
	ac_cv_path_ssh=/usr/bin/ssh
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/rc.d/init.d,/var/run/%{name},%{_bindir},%{_mandir}/man1} \
	$RPM_BUILD_ROOT%{systemdtmpfilesdir}

install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/autossh.tab
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{systemdtmpfilesdir}/%{name}.conf

install -p autossh $RPM_BUILD_ROOT%{_bindir}
cp -p autossh.1 $RPM_BUILD_ROOT%{_mandir}/man1

%clean
rm -rf $RPM_BUILD_ROOT

%post init
/sbin/chkconfig --add autossh
%service autossh restart "autossh"

%preun init
if [ "$1" = "0" ]; then
	%service autossh stop
	/sbin/chkconfig --del autossh
fi

%files
%defattr(644,root,root,755)
%doc README CHANGES autossh.host rscreen
%attr(755,root,root) %{_bindir}/autossh
%{_mandir}/man1/autossh.1*

%files init
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{name}.tab
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%{systemdtmpfilesdir}/%{name}.conf
%dir /var/run/autossh
%changelog
* Sat Dec 30 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/autossh.git;a=log;h=master

* Sat Dec 30 2023 Jakub Bogusz <qboosh@pld-linux.org> 44310f5
- updated to 1.4g, drop -lnsl from linking

* Wed Mar 27 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> fab12c9
- up to 1.4f

* Mon Feb 13 2017 mis <mistoo@gmail.com> e4cdb14
- up to 1.4d

* Mon May 28 2012 Elan Ruusamäe <glen@pld-linux.org> 259dbeb
- local vars

* Mon May 28 2012 Elan Ruusamäe <glen@pld-linux.org> 59181a0
- pass path to ssh via cache value, this works at least

* Mon May 28 2012 Elan Ruusamäe <glen@pld-linux.org> be67489
- epoch not defined

* Mon May 28 2012 Elan Ruusamäe <glen@pld-linux.org> 4ad402f
- systemd macros

* Mon May 28 2012 Elan Ruusamäe <glen@pld-linux.org> 7d8d706
- pass path to ssh

* Sat Feb 11 2012 zbyniu <zbyniu@pld-linux.org> 0e465fe
- up to 1.4c

* Mon Feb 06 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 330eec3
- No empty pidfile/config.

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> 9d9131e
- release 4

* Mon Jan 30 2012 Jan Rękorajski <baggins@pld-linux.org> 12fe5d5
- rel 3
- added tmpfiles config for systemd

* Mon Jan 30 2012 Jan Rękorajski <baggins@pld-linux.org> 963f54e
- add systemd tmpfiles config

* Wed Jun 24 2009 pawelz <pawelz@pld-linux.org> 1080c57
- better example

* Wed Jun 24 2009 pawelz <pawelz@pld-linux.org> a0a31d2
- start/stop service in %post/%pre scriptlets of init subpackage

* Tue May 19 2009 pawelz <pawelz@pld-linux.org> b5a5962
- R: openssh-clients
- adapterized

* Tue May 19 2009 pawelz <pawelz@pld-linux.org> 9c62d43
- added init subpackage containig init script
- more verbose %files
- rel 2

* Tue May 19 2009 pawelz <pawelz@pld-linux.org> 8ccce38
- init script for autossh

* Tue May 19 2009 pawelz <pawelz@pld-linux.org> 615fa6c
- example config file for autossh-init

* Fri Apr 18 2008 areq <areq@pld-linux.org> 3a9f495
- 1.4b

